"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Accordion = Accordion;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _excluded = ["headingLevel", "items", "className", "id"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function Accordion(props) {
  var accordionRef = (0, _react.useRef)();
  var headingLevel = props.headingLevel,
      items = props.items,
      className = props.className,
      id = props.id,
      attributes = (0, _objectWithoutProperties2["default"])(props, _excluded);
  (0, _react.useEffect)(function () {
    (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var _yield$import, AccordionJS;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(typeof document !== 'undefined')) {
                _context.next = 6;
                break;
              }

              _context.next = 3;
              return import(
              /* webpackChunkName: "govuk-frontend-accordion" */

              /* webpackMode: "lazy" */

              /* webpackPrefetch: true */
              'govuk-frontend/govuk/components/accordion/accordion');

            case 3:
              _yield$import = _context.sent;
              AccordionJS = _yield$import["default"];

              if (accordionRef.current) {
                new AccordionJS(accordionRef.current).init();
              }

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  }, [accordionRef]);
  var HeadingLevel = headingLevel ? "h".concat(headingLevel) : 'h2';
  var innerHtml = items.map(function (item, index) {
    if (!item) {
      return;
    }

    return /*#__PURE__*/_react["default"].createElement("div", {
      key: item.reactListKey || index,
      className: "govuk-accordion__section ".concat(item.expanded ? 'govuk-accordion__section--expanded' : '')
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "govuk-accordion__section-header"
    }, /*#__PURE__*/_react["default"].createElement(HeadingLevel, {
      className: "govuk-accordion__section-heading"
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: "govuk-accordion__section-button",
      id: "".concat(id, "-heading-").concat(index + 1)
    }, item.heading.children)), item.summary ? /*#__PURE__*/_react["default"].createElement("div", {
      className: "govuk-accordion__section-summary govuk-body",
      id: "".concat(id, "-summary-").concat(index + 1)
    }, item.summary.children) : ''), /*#__PURE__*/_react["default"].createElement("div", {
      id: "".concat(id, "-content-").concat(index + 1),
      className: "govuk-accordion__section-content",
      "aria-labelledby": "".concat(id, "-heading-").concat(index + 1)
    }, item.content.children));
  });
  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, attributes, {
    id: id,
    className: "govuk-accordion ".concat(className || ''),
    "data-module": "govuk-accordion",
    ref: accordionRef
  }), innerHtml);
}