"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ErrorMessage = ErrorMessage;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _excluded = ["className", "children", "visuallyHiddenText"];

function ErrorMessage(props) {
  var className = props.className,
      children = props.children,
      visuallyHiddenText = props.visuallyHiddenText,
      attributes = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var visuallyHiddenTextComponent;

  if (visuallyHiddenText) {
    visuallyHiddenTextComponent = /*#__PURE__*/_react["default"].createElement("span", {
      className: "govuk-visually-hidden"
    }, visuallyHiddenText, ": ");
  }

  return /*#__PURE__*/_react["default"].createElement("p", (0, _extends2["default"])({
    className: "govuk-error-message ".concat(className || '')
  }, attributes), visuallyHiddenTextComponent, children);
}

ErrorMessage.defaultProps = {
  visuallyHiddenText: 'Error'
};