"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ErrorSummary = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _excluded = ["className", "descriptionChildren", "errorList", "titleChildren", "disableAutoFocus"],
    _excluded2 = ["reactListKey", "children", "href"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var defaultRef = /*#__PURE__*/_react["default"].createRef();

var ErrorSummary = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var className = props.className,
      descriptionChildren = props.descriptionChildren,
      errorList = props.errorList,
      titleChildren = props.titleChildren,
      disableAutoFocus = props.disableAutoFocus,
      attributes = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var errorSummaryRef = ref || defaultRef;
  (0, _react.useEffect)(function () {
    (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var _yield$import, ErrorSummaryJS;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(typeof document !== 'undefined')) {
                _context.next = 6;
                break;
              }

              _context.next = 3;
              return import(
              /* webpackChunkName: "govuk-frontend-error-summary" */

              /* webpackMode: "lazy" */

              /* webpackPrefetch: true */
              'govuk-frontend/govuk/components/error-summary/error-summary');

            case 3:
              _yield$import = _context.sent;
              ErrorSummaryJS = _yield$import["default"];

              if (errorSummaryRef.current) {
                // Just bind the click event handlers from the gov error summary
                // This is because we don't want to focus by default - that's up to the calling app
                errorSummaryRef.current.addEventListener('click', ErrorSummaryJS.prototype.handleClick.bind(ErrorSummaryJS.prototype));
              }

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  }, [errorSummaryRef]);
  var description;

  if (descriptionChildren) {
    description = /*#__PURE__*/_react["default"].createElement("p", null, descriptionChildren);
  }

  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    className: "govuk-error-summary ".concat(className || ''),
    "aria-labelledby": "error-summary-title",
    role: "alert",
    "data-disable-auto-focus": disableAutoFocus ? 'true' : null
  }, attributes, {
    "data-module": "govuk-error-summary",
    ref: errorSummaryRef
  }), /*#__PURE__*/_react["default"].createElement("h2", {
    className: "govuk-error-summary__title",
    id: "error-summary-title"
  }, titleChildren), /*#__PURE__*/_react["default"].createElement("div", {
    className: "govuk-error-summary__body"
  }, description, /*#__PURE__*/_react["default"].createElement("ul", {
    className: "govuk-list govuk-error-summary__list"
  }, errorList ? errorList.map(function (error, index) {
    var reactListKey = error.reactListKey,
        children = error.children,
        href = error.href,
        errorAttributes = (0, _objectWithoutProperties2["default"])(error, _excluded2);
    return /*#__PURE__*/_react["default"].createElement("li", {
      key: reactListKey || index
    }, href ? /*#__PURE__*/_react["default"].createElement("a", (0, _extends2["default"])({}, errorAttributes, {
      href: href
    }), children) : /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, children));
  }) : null)));
});

exports.ErrorSummary = ErrorSummary;
ErrorSummary.defaultProps = {
  titleChildren: 'There is a problem'
};
ErrorSummary.displayName = 'ErrorSummary';