"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Fieldset = Fieldset;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _excluded = ["legend", "className", "children"];

function Fieldset(props) {
  var legend = props.legend,
      className = props.className,
      children = props.children,
      attributes = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var legendComponent;

  if (legend && legend.children) {
    legendComponent = /*#__PURE__*/_react["default"].createElement("legend", {
      className: "govuk-fieldset__legend ".concat(legend.className || '')
    }, legend.isPageHeading ? /*#__PURE__*/_react["default"].createElement("h1", {
      className: "govuk-fieldset__heading"
    }, legend.children) : legend.children);
  }

  return /*#__PURE__*/_react["default"].createElement("fieldset", (0, _extends2["default"])({
    className: "govuk-fieldset ".concat(className || '')
  }, attributes), legendComponent, children);
}