"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tabs = Tabs;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _excluded = ["className", "id", "idPrefix", "items", "title"],
    _excluded2 = ["id", "label", "panel"],
    _excluded3 = ["id", "panel", "label"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function Tabs(props) {
  var className = props.className,
      id = props.id,
      idPrefix = props.idPrefix,
      items = props.items,
      title = props.title,
      attributes = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var tabsRef = (0, _react.useRef)();
  (0, _react.useEffect)(function () {
    (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var _yield$import, TabsJS;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(typeof document !== 'undefined')) {
                _context.next = 6;
                break;
              }

              _context.next = 3;
              return import(
              /* webpackChunkName: "govuk-frontend-tabs" */

              /* webpackMode: "lazy" */

              /* webpackPrefetch: true */
              'govuk-frontend/govuk/components/tabs/tabs');

            case 3:
              _yield$import = _context.sent;
              TabsJS = _yield$import["default"];

              if (tabsRef.current) {
                new TabsJS(tabsRef.current).init();
              }

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  }, [tabsRef]);
  var filteredItems = items ? items.filter(function (item) {
    return item;
  }) : [];
  var tabContent = filteredItems.map(function (item, index) {
    // eslint-disable-next-line no-unused-vars
    var itemId = item.id,
        label = item.label,
        panel = item.panel,
        itemAttributes = (0, _objectWithoutProperties2["default"])(item, _excluded2);
    var tabId = "".concat(itemId || "".concat(idPrefix, "-").concat(index + 1));
    return /*#__PURE__*/_react["default"].createElement("li", {
      key: tabId,
      className: "govuk-tabs__list-item".concat(index === 0 ? ' govuk-tabs__list-item--selected' : '')
    }, /*#__PURE__*/_react["default"].createElement("a", (0, _extends2["default"])({
      className: "govuk-tabs__tab",
      href: "#".concat(tabId)
    }, itemAttributes), label));
  });
  var tabs = filteredItems.length > 0 ? /*#__PURE__*/_react["default"].createElement("ul", {
    className: "govuk-tabs__list"
  }, tabContent) : null;
  var panels = filteredItems.map(function (item, index) {
    // eslint-disable-next-line no-unused-vars
    var itemId = item.id,
        panel = item.panel,
        label = item.label,
        itemAttributes = (0, _objectWithoutProperties2["default"])(item, _excluded3);
    var panelId = "".concat(itemId || "".concat(idPrefix, "-").concat(index + 1));
    return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
      key: panelId,
      className: "govuk-tabs__panel".concat(index > 0 ? ' govuk-tabs__panel--hidden' : ''),
      id: panelId
    }, panel));
  });
  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    id: id,
    className: "govuk-tabs ".concat(className || '')
  }, attributes, {
    "data-module": "govuk-tabs",
    ref: tabsRef
  }), /*#__PURE__*/_react["default"].createElement("h2", {
    className: "govuk-tabs__title"
  }, title), tabs, panels);
}

Tabs.defaultProps = {
  title: 'Contents',
  idPrefix: ''
};